/* board_rd3ay.c */

#include <stdlib.h>
#include <assert.h>


/* Pin manipulation functions */
#include <avr/io.h>
#include <util/delay.h>
//#include <avr/pgmspace.h>

#include "board.h"
#include "product.h"
#include "synthcalcs.h"
#include "spifuncs.h"


#if BOARD_SUPPORT_RD3AY


#include "chip\ad9832.c"


#if defined (__AVR_ATmega128__)

#define MCU_TARGET_PORT PORTC

#elif defined (__AVR_ATmega32__) || defined (__AVR_ATmega16__)

#define MCU_TARGET_PORT PORTC

#endif

void
lpt_writeb(unsigned char c)
{
	MCU_TARGET_PORT = c;
}

void
lpt_and_writeb(unsigned char data, unsigned char mask)
{
	MCU_TARGET_PORT = (MCU_TARGET_PORT & ~ mask) | (data & mask);
}

void lpt_set_d0_0(void)
{
	MCU_TARGET_PORT &= ~0x01;
}

void lpt_set_d0_1(void)
{
	MCU_TARGET_PORT |= 0x01;
}

/*
void lpt_set_d0(uint8_t value)
{
	if (value)
		MCU_TARGET_PORT |= 0x01;
	else
		MCU_TARGET_PORT &= ~0x01;
}
*/

void lpt_set_d1(uint8_t value)
{
	if (value != 0)
		MCU_TARGET_PORT |= 0x02;
	else
		MCU_TARGET_PORT &= ~0x02;
}

/*
void lpt_set_d2(uint8_t value)
{
	if (value)
		MCU_TARGET_PORT |= 0x04;
	else
		MCU_TARGET_PORT &= ~0x04;
}

void lpt_set_d3(uint8_t value)
{
	if (value)
		MCU_TARGET_PORT |= 0x08;
	else
		MCU_TARGET_PORT &= ~0x08;
}

void lpt_set_d4(uint8_t value)
{
	if (value)
		MCU_TARGET_PORT |= 0x10;
	else
		MCU_TARGET_PORT &= ~0x10;
}

*/

void lpt_set_d5(uint8_t value)
{
	if (value)
		MCU_TARGET_PORT |= 0x20;
	else
		MCU_TARGET_PORT &= ~0x20;
}

void lpt_set_d6(uint8_t value)
{
	if (value)
		MCU_TARGET_PORT |= 0x40;
	else
		MCU_TARGET_PORT &= ~0x40;
}

void lpt_set_d7(uint8_t value)
{
	if (value)
		MCU_TARGET_PORT |= 0x80;
	else
		MCU_TARGET_PORT &= ~0x80;
}



const phase_t phase_0 = 0;


/*       CD4016 */
static void writeserialctl(void)
{
	unsigned char target = -1;

	prog_bit(target, 0);		// U7A output: J6-1 D0
	prog_bit(target, 0);		// U7A output: J6-4 D1
	prog_bit(target, 0);		// U7A output: J6-3 D2
	prog_bit(target, 0);		// U7A output: J6-2 D3

	prog_bit(target, 0);		// unused output of U6B
	prog_bit(target, 0);		// VFO divider value 2 pow 2
	prog_bit(target, 0);		// VFO divider 2 pow 1
	prog_bit(target, 0);		// VFO divider 2 pow 0

	prog_bit(target, 0);		// unused output of U6A
	prog_bit(target, 0);		// output of U6A - Q2 base - connect C12
	prog_bit(target, 0);		// output of U6A - Q3 base - connect C11
	prog_bit(target, 0);		// output of U6A - Q4 base - connect C16

}


/*      74HC595 */
static void writeserialctl2(void)
{
	unsigned char target = -1;

	prog_select(target, 1);

	prog_bit(target, 0);		// U3 output 7: J4-8 KB_RES
	prog_bit(target, 0);		// U3 output 6: J4-7 CW
	prog_bit(target, 0);		// U3 output 5: J4-6 FTR
	prog_bit(target, 0);		// U3 output 4: J4-5 AGC
	prog_bit(target, 0);		// U3 output 3: J4-4 REV
	prog_bit(target, 0);		// U3 output 2: J4-3 PPWR
	prog_bit(target, 0);		// U3 output 1: J4-2 ATT
	prog_bit(target, 0);		// U3 output 15: unused


	prog_select(target, 0);	// rise RCLK (12) of 74HC595

}


/* make pulse on ioupdate line */
void prog_pulse_ioupdate(void)
{
	//lpt_set_d7(1);
  //_delay_us(1);               /* guarantee 1000 ns high */
	//lpt_set_d7(0);
}


void prog_vfo_select(long freq)		/*  ,    . */
{


}

void prog_vfo_divider(long divider)	/*     */
{

}



void prog_dds1_ftw(const phase_t * value, unsigned char freqpow, unsigned char ddsmult)
{
	prog_ad9832_freq(targetdds1, value);
	prog_pulse_ioupdate();
}

/*     ,    ssb      /  . 
 ,              .
 */ 
void prog_dds2_ftw(const phase_t * value, unsigned char freqpow, unsigned char ddsmult)
{

}



void board_set_att(unsigned char v)
{

}

void board_set_agc(unsigned char off, unsigned char code)
{

}


void board_set_detector(unsigned char v)
{

}

void board_set_filter(unsigned char v)
{

}

/*    -        */
void board_set_lsb(unsigned char v)	/*      */
{

}
void board_init_io(void)
{
	prog_select_init();		// spi initialize
	prog_pulse_ioreset();
	board_ctl_init();
}

void board_init(unsigned char ddsmult)
{
	prog_ad9832_init(targetdds1);

}


void nvram_initialize(void)
{
}

void nvram_write(unsigned addr, void * data, unsigned len)
{
}

void nvram_read(unsigned addr, void * data, unsigned len)
{
}


#endif /* BOARD_SUPPORT_RD3AY */

