// not tested at all.

#ifndef AD9832_H_INCLUDED
#define AD9832_H_INCLUDED

/*

0xF8, 0x00		; SLEEP = RESET = CLR = 1
0xB0, 0x00	; SYNC = SELSRC = 1
0xC0, 0x00	; SLEEP = RESET = 0

   

   1 -   0-
0x30, ftw_07_00
0x21, ftw_15_00
0x32, ftw_23_16
0x23, ftw_31_24

0x50, 0x00 -    0

,  1-
0x34, ftw_07_00
0x25, ftw_15_00
0x36, ftw_23_16
0x27, ftw_31_24

0x58, 0x00 -    1



*/

static unsigned char lastused [8];

/* internal data */
void prog_ad9832_setfreq(
	unsigned char target,	/* addressing to chip */
	const phase_t * ftw		/* ftw value */
			 )
{
	const unsigned char newused = ! lastused [target];

	/*    1 -   0- */
	prog_select(target, 1);	/* start sending data to target chip */
	prog_val(target, newused ? 0x34 : 0x30, 8); 
	prog_phbits(target, ftw, 8, 8);
	prog_select(target, 0);	/* done sending data to target chip */

	prog_select(target, 1);	/* start sending data to target chip */
	prog_val(target, newused ? 0x25 : 0x21, 8); 
	prog_phbits(target, ftw, 16, 8);
	prog_select(target, 0);	/* done sending data to target chip */

	prog_select(target, 1);	/* start sending data to target chip */
	prog_val(target, newused ? 0x36 : 0x32); 
	prog_phbits(target, ftw, 24, 8);
	prog_select(target, 0);	/* done sending data to target chip */

	prog_select(target, 1);	/* start sending data to target chip */
	prog_val(target, newused ? 0x27 : 0x23, 8); 
	prog_phbits(target, ftw, 32, 8);
	prog_select(target, 0);	/* done sending data to target chip */

	/*    0 */ 
	prog_select(target, 1);	/* start sending data to target chip */
	prog_val(target, newused ? 0x58 : 0x50, 8); 
	prog_val(target, 0x00, 8); 
	prog_select(target, 0);	/* done sending data to target chip */

	lastused [target] = newused;
}




/* programming AD9832 */
void prog_ad9832_init(
	unsigned char target	/* addressing to chip */
			 )
{
//0xF8, 0x00		; SLEEP = RESET = CLR = 1
		prog_select(target, 1);	/* start sending data to target chip */
		prog_val(target, 0xF8, 8); 
		prog_val(target, 0x00, 8); 
		prog_select(target, 0);	/* done sending data to target chip */
//0xB0, 0x00	; SYNC = SELSRC = 1
		prog_select(target, 1);	/* start sending data to target chip */
		prog_val(target, 0xB0, 8); 
		prog_val(target, 0x00, 8); 
		prog_select(target, 0);	/* done sending data to target chip */
//0xC0, 0x00	; SLEEP = RESET = 0
		prog_select(target, 1);	/* start sending data to target chip */
		prog_val(target, 0xC0, 8); 
		prog_val(target, 0x00, 8); 
		prog_select(target, 0);	/* done sending data to target chip */
}

#endif /* AD9832_H_INCLUDED */
