//#include <stdio.h>
//#include <stdlib.h>
//#include <math.h>

#include <avr/io.h>

#include "product.h"
#include "synthcalcs.h"
#include "board.h"

/* 
	     
	    
	 .

	 -   mgs2001@pochtamt.ru
*/


//typedef signed long long ftw_t;	/* ,         */

//static int r1; // = SYNTH_R1;			/*   DDS -     PLL */
static ftw_t osc; // =  SYNTH_DDSOSC;   /*     DDS */



#if defined (LO1MODE_HYBRID)
ftw_t r1_ph; // = SYNTH_R1;
static ftw_t ph1_min; // = freq2ftw(osc, cf - df / 2);	/* ,      DDS */
#endif


#if defined (LO1MODE_FIXSCALE)
ftw_t r1_ph; // = SYNTH_R1;
#endif


/*      FTW     DDS */
static ftw_t freq2ftw(ftw_t freq)
{
        ftw_t t = (ftw_t) freq << PHASE_RESOLUTION;		/*       */
        return t / osc;
}

#if defined (LO1MODE_FIXSCALE)
static ftw_t osc_m;	// =  osc * r1;   /*     DDS -   -     */
/*      FTW     DDS */
static ftw_t freq2ftw_divm(ftw_t freq)
{
        ftw_t t = (ftw_t) freq << PHASE_RESOLUTION;		/*       */
        return t / osc_m;
}
#endif
/*     -   FTW      DDS */
//static double ftw2freq(long osc, ftw_t phase)
//{
//        return (double) osc * phase / pow(2, PHASE_RESOLUTION);
//}


void synth_init(
	unsigned long ddsclock, 	/*       */
	unsigned char ddsmult)
{

#if defined (LO1MODE_HYBRID)
	long freqlow = SYNTH_FREQMIN;	/*     */
	/*   -         ,     */
	r1_ph = SYNTH_R1;			/*   DDS -     PLL */
	freqlow = SYNTH_FREQMIN;	/*     */
#endif

	osc =  ddsclock;   /*     DDS */
#if defined (LO1MODE_FIXSCALE)
  	r1_ph = SYNTH_R1;			/*      PLL */
    osc_m =  osc * r1_ph;   /*     DDS -   -     */
#endif

#if defined (LO1MODE_HYBRID)
    ftw_t cf =   SYNTH_CFCENTER;   /*      DDS */
    ftw_t df =   (ftw_t) (((ftw_t)cf * cf) / (freqlow * r1_ph));   /*      DDS */
    ph1_min = freq2ftw(cf - df / 2);	/* ,      DDS */
#endif

	/*        DDS */
    //printf("dds center = %ld kHz, dds bw = %ld kHz\n", cf / 1000, df / 1000);

	/*   (  ) .    */
	//prog_pll1_r(& r1_ph);

	board_init(ddsmult);	//  ...   .
}

#if defined (LO1MODE_FIXSCALE)
/* 	DDS      , 
 *	     .  SYNTH_R1
 */
static void synth_scale1_setfreq(
	unsigned long fq1	/* ,        */
	)
{
	ftw_t ph1 = freq2ftw_divm(fq1);    /*      */

	prog_vfo_select(fq1);	/*  ,     */
	//prog_vfo_divider(divider);	/*     */
	prog_dds1_ftw(& ph1, 0, DDS_CLOCK_MULT);
}
#endif

#if defined (LO1MODE_DIRECT)

static void synth_direct_setfreq(
	unsigned long fq1	/* ,      DDS */
	)
{
	ftw_t ph1 = freq2ftw(fq1);    /*      */
	prog_dds1_ftw(& ph1, 0, DDS_CLOCK_MULT);

}
#endif

void synth_lo3_setfreq(
	unsigned long fq1,	/* ,      DDS */
	unsigned char freqpow
	)
{
	ftw_t ph1 = freq2ftw(fq1);    /*      */
	prog_dds2_ftw(& ph1, freqpow, DDS_CLOCK_MULT);
}


#if defined (LO1MODE_HYBRID)

static void synth_loop1_setfreq(
	ftw_t fq1	/* ,        */
	)
{

	ftw_t ph1_m;
	ftw_t n1;
	ftw_t ph1a;


#if 0
		/*    (     -    */
    ph1_m = freq2ftw(fq1) * r1_ph;   /*       */
#else
		/*     */
    ph1_m = freq2ftw(fq1 * r1_ph);   /*       */
#endif

	//  

    n1 = (ph1_m / ph1_min);		/*       PLL */

    ph1a = ph1_m / n1;		/* FTW  DDS */

	/*      -        */        

    //printf("DDS out = %6.6f Hz\n", ftw2freq(osc, ph1a));
    //printf("PLL R/N = %ld/%ld\n", (long) r1, (long) n1);
    //printf("PLL out = %6.6f Hz (desired = %6.6f Hz)\n", ftw2freq(osc, ph1a) * n1 / r1, (double) fq1);
	prog_vfo_select(fq1);	/*  ,     */
	//prog_vfo_divider(divider);	/*     */
	prog_dds1_ftw(& ph1a, 0, DDS_CLOCK_MULT);
	prog_pll1_n(& n1);

}
#endif

/*    ,    */
void synth_lo1_setfreq(uint32_t freq)
{
#if LO1DIVIDEVCO
	/*    VCO       
	*/
		uint32_t divider = (SYNTH_FREQMIN * 2UL) / freq;
		prog_vfo_divider(divider);
		freq *= divider;
#endif

#if defined (LO1MODE_DIRECT)
		synth_direct_setfreq(freq);
#elif defined (LO1MODE_HYBRID)
		synth_loop1_setfreq(freq);
#elif defined (LO1MODE_FIXSCALE)
		synth_scale1_setfreq(freq);
#else
		#error Select proper LO1MODE_XXX define!
#endif
}
