/* board.h */
/* Pin manipulation functioms */

#ifndef BOARD_H_INCLUDED
#define BOARD_H_INCLUDED


#include "synthcalcs.h"

// d0 - clk	
// d1 - sdata	
// d2 - asel0	
// d3 - asel1
// d4 - asel2
// d5 - aselen
// d6 -	iores
// d7 -	ioupd
/*
void lpt_set_d0(uint8_t status);
void lpt_set_d1(uint8_t status);
void lpt_set_d2(uint8_t status);
void lpt_set_d3(uint8_t status);
void lpt_set_d4(uint8_t status);
void lpt_set_d5(uint8_t status);
void lpt_set_d6(uint8_t status);
void lpt_set_d7(uint8_t status);
*/
//
//

//void lpt_writeb(unsigned char c);
//void lpt_and_writeb(unsigned char data, unsigned char mask);


void board_init_io(void);
void board_init(unsigned char ddsmult);
void prog_pulse_ioreset(void);
void prog_pulse_ioupdate(void);
void prog_select_init(void);

void prog_vfo_select(long freq);		/*  ,    . */
void prog_vfo_divider(long divider);	/*     */


void prog_dds1_ftw(const phase_t * value, unsigned char freqpow, unsigned char ddsmult);
void prog_dds2_ftw(const phase_t * value, unsigned char freqpow, unsigned char ddsmult);
//void prog_pll1_r(const phase_t * value);
void prog_pll1_n(const phase_t * value);


void nvram_initialize(void);
void nvram_write(uint16_t addr, void * data, unsigned len);
void nvram_read(uint16_t addr, void * data, unsigned len);


void board_set_att(unsigned char v);
void board_set_agc(unsigned char off, unsigned char code);

void board_set_detector(unsigned char v);
void board_set_filter(unsigned char v);
void board_set_lsb(unsigned char v);	/*      */

/*    - bandpass.c */

void board_bandf_initialize();
void board_bandf_setfreq(unsigned long freq);


#define targetdds1 0	/* DDS1 */
#define targetdds2 1	/* DDS2 - LO3 output */
#define targetpll1 2	/* lmx2306 after DDS1 - divide by r1 and scale to n1 */
#define targetpll2 3	/* lmx2306 - fixed 2-nd LO generate */ 
#define targetamp1 4	/* ad8321 amplifier */
#define targetamp2 5	/* ad8321 amplifier */
#define targetamp3 6	/* ad8321 amplifier */
#define targetctl1 7	/* control register */

#define targetnvram 255	/* nvram serial nvram */

#endif /* BOARD_H_INCLUDED */
