/* product.h	*/

#ifndef PRODUCT_H_INCLUDED
#define PRODUCT_H_INCLUDED

#define BOARD_SUPPORT_UA1ARN 1
//#define BOARD_SUPPORT_RD3AY 1
//#define BOARD_SUPPORT_RU3GA 1 / RU3GA & RK4FB board
//#define BOARD_SUPPORT_UT2FW 1
//#define BOARD_SUPPORT_DCRX 1		//     DDS  


//#define CANADAPSEL 1

/*   -   */

//#define MODEL_45	  		1	// Universal synth - 1-st IF=45, 2-nd IF=0.5
//#define MODEL_45WIDE	  		1	// Universal synth - 1-st IF=45, 2-nd IF=0.5
//#define MODEL_35			1	// KATRAN
//#define MODEL_70			1	// 1-st IF=70, 2-nd IF=0.5
//#define MODEL_80455		1	// 1-st IF=80.455, 2-nd IF=0.455
#define MODEL_64455		1	// 1-st IF=64.455, 2-nd IF=0.455
//#define MODEL_USC52		1	// upscaler - 1-st IF=45, 2-nd IF=5.0
//#define MODEL_65_185		1	// Universal synth - 1-st IF=45, 2-nd IF=5.0
//#define MODEL_UPS9951		1	// Universal synth - 1-st IF=45, 2-nd IF=5.0
//#define MODEL_70M2	1	// with filter from EKD-300
//#define MODEL_8P8	  		1	// 1-st if - 8.886 MHz
//#define MODEL_4Z5KY	1
//#define MODEL_RD3AY	1
//#define MODEL_DCRX	1		//     DDS   


#define BOARD_TYPE_DDS7	1
//#define BOARD_TYPE_UPSC52	1
//#define BOARD_TYPE_UPSC9951	1

//#define LO1MODE_DIRECT	1
//#define LO1MODE_HYBRID	1
//#define LO1MODE_FIXSCALE	1	// also used SYNTH_R1


/*    */

#define DDS_TYPE_AD9852		1	
#define DDS_TYPE_AD9857		2
#define DDS_TYPE_AD9951		3
#define DDS_TYPE_AD5932		4
#define DDS_TYPE_AD5930		5
#define DDS_TYPE_AD9834		6
#define DDS_TYPE_AD9851		7
#define DDS_TYPE_AD9832		7

#define PLL_TYPE_LMX2306	10
#define PLL_TYPE_ADF4001	11
#define PLL_TYPE_MC145170	12

#define AMP_TYPE_AD8320		20
#define AMP_TYPE_AD8321		21

#define NVRAM_TYPE_FM25L04		22	/* SERIAL FRAM 4KBit	*/
#define NVRAM_TYPE_FM25L16		23	/* SERIAL FRAM 16Kbit	*/
#define NVRAM_TYPE_AT25L04		24  /* SERIAL EEPROM 16KBit	*/
#define NVRAM_TYPE_AT25L16		25  /* SERIAL EEPROM 16KBit	*/
#define NVRAM_TYPE_ATMEGA			26	/*    */

/*          */
#define NVRAM_TYPE NVRAM_TYPE_FM25L04
//#define NVRAM_TYPE NVRAM_TYPE_AT25L04
//#define NVRAM_TYPE NVRAM_TYPE_ATMEGA


#if defined (NVRAM_TYPE) && (NVRAM_TYPE == NVRAM_TYPE_FM25L04)
#define NVRAM_SIZE 512
#elif defined (NVRAM_TYPE) && (NVRAM_TYPE == NVRAM_TYPE_AT25L04)
#define NVRAM_SIZE 512
#elif defined (NVRAM_TYPE) && (NVRAM_TYPE == NVRAM_TYPE_FM25L16)
#define NVRAM_SIZE 2048
#elif defined (NVRAM_TYPE) && (NVRAM_TYPE == NVRAM_TYPE_AT25L16)
#define NVRAM_SIZE 2048
#elif defined (NVRAM_TYPE) && (NVRAM_TYPE == NVRAM_TYPE_ATMEGA)

#if defined (__AVR_ATmega128__)
#define NVRAM_SIZE 4096
#elif defined (__AVR_ATmega32__)
#define NVRAM_SIZE 1024
#elif defined defined (__AVR_ATmega16__)
#define NVRAM_SIZE 512
#endif

#endif

#define IF3_TYPE_455	1
#define IF3_TYPE_500	2
#define IF3_TYPE_215	3
#define IF3_TYPE_8868	4
#define IF3_TYPE_DCRX	5


// 
#if MODEL_45WIDE
#define LO1MODE_HYBRID	1
// model 45.1-85
#define REFERENCE_FREQ	12800000L
#define LO2_PLL_R	128		/* For 0.1 MHz phase detector freq */
#define IMU 1
#define LO2_PLL_R_CALC	(IMU*LO2_PLL_R)		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */
#define DDS_CLOCK_MULT (IMU)
#define SYNTH_DDSOSC	(IMU*REFERENCE_FREQ)	  /*     DDS */
#define	DDSAD9951CLKGT250	0		/* set to 1 if dds clock greater then 250 MHz */


#define SYNTH_R1 25	/*   DDS -     PLL */
#define SYNTH_FREQMIN	45100000L		/*     */
#define SYNTH_CFCENTER	10700000L	/*      DDS */

#define FREQ_DENOM 1000000L
#define FREQ_SCALE 1157650L

/*   */

#define IF1_INVERSE	0	// true: the lo LO2 in above IF1 (true, if 45.5 MHz)

#if IF1_INVERSE
#define LO2_PLL_N	455		/* for 45.5 MHz LO2 */
#else
#define LO2_PLL_N	445		/* for 44.5 MHz LO2 */
#endif

#define PHASE_RESOLUTION 28	/*  FTW  DDS */
//#define PHASE_RESOLUTION 32	/*  FTW  DDS */


/* Board hardware configuration */
#define PLL1_TYPE PLL_TYPE_ADF4001
#define PLL2_TYPE PLL_TYPE_ADF4001
#define DDS1_TYPE DDS_TYPE_AD9834
//#define DDS1_TYPE DDS_TYPE_AD9852
//#define DDS1_TYPE DDS_TYPE_AD9951
//#define DDS2_TYPE DDS_TYPE_AD9852
//#define DDS2_TYPE DDS_TYPE_AD9951
#define DDS2_TYPE DDS_TYPE_AD9834

//#define AMP1_TYPE AMP_TYPE_AD8320
//#define AMP2_TYPE AMP_TYPE_AD8320
//#define AMP3_TYPE AMP_TYPE_AD8320

#define LO3_POWER 0 //2
#define TUNE_BOTTOM 100000
#define TUNE_TOP 36000000


#define LO2FREQ (REFERENCE_FREQ / LO2_PLL_R * LO2_PLL_N)



#endif // Model 45_wide

#if MODEL_45
#define LO1MODE_HYBRID	1
// model 45-75
#define REFERENCE_FREQ	12800000L
#define LO2_PLL_R	128		/* For 0.1 MHz phase detector freq */
#define IMU 1
#define LO2_PLL_R_CALC	(IMU*LO2_PLL_R)		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */
#define DDS_CLOCK_MULT (IMU)
#define SYNTH_DDSOSC	(IMU*REFERENCE_FREQ)	  /*     DDS */
#define	DDSAD9951CLKGT250	0		/* set to 1 if dds clock greater then 250 MHz */


#define SYNTH_R1 25	/*   DDS -     PLL */
#define SYNTH_FREQMIN	45100000L		/*     */
#define SYNTH_CFCENTER	10700000L	/*      DDS */

#define FREQ_DENOM 1000000L
#define FREQ_SCALE 1157650L

/*   */

#define IF1_INVERSE	0	// true: the lo LO2 in above IF1 (true, if 45.5 MHz)

#if IF1_INVERSE
#define LO2_PLL_N	455		/* for 45.5 MHz LO2 */
#else
#define LO2_PLL_N	445		/* for 44.5 MHz LO2 */
#endif

#define PHASE_RESOLUTION 28	/*  FTW  DDS */
//#define PHASE_RESOLUTION 32	/*  FTW  DDS */


/* Board hardware configuration */
#define PLL1_TYPE PLL_TYPE_ADF4001
#define PLL2_TYPE PLL_TYPE_ADF4001
#define DDS1_TYPE DDS_TYPE_AD9834
//#define DDS1_TYPE DDS_TYPE_AD9852
//#define DDS1_TYPE DDS_TYPE_AD9951
//#define DDS2_TYPE DDS_TYPE_AD9852
//#define DDS2_TYPE DDS_TYPE_AD9951
#define DDS2_TYPE DDS_TYPE_AD9834

//#define AMP1_TYPE AMP_TYPE_AD8320
//#define AMP2_TYPE AMP_TYPE_AD8320
//#define AMP3_TYPE AMP_TYPE_AD8320

#define LO3_POWER 0 //2
#define TUNE_BOTTOM 100000
#define TUNE_TOP 36000000


#define LO2FREQ (REFERENCE_FREQ / LO2_PLL_R * LO2_PLL_N)



#endif // Model 45

#if MODEL_80455

#define IF3_MODEL IF3_TYPE_455
#define LO1MODE_HYBRID	1
// model 

#define REFERENCE_FREQ	12800000L
#define LO2_PLL_R	4		/* For 3.2 MHz phase detector freq */
#define IMU 1				/*   DDS */
#define LO2_PLL_R_CALC	(IMU*LO2_PLL_R)		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */
#define DDS_CLOCK_MULT (IMU)
#define SYNTH_DDSOSC	(IMU*REFERENCE_FREQ)	  /*     DDS */
#define	DDSAD9951CLKGT250	0		/* set to 1 if dds clock greater then 250 MHz */


#define SYNTH_R1 13	/*   DDS -     PLL */
#define SYNTH_FREQMIN	80550000L		/*     */
#define SYNTH_CFCENTER	10700000L	/*      DDS */

#define FREQ_DENOM 1000000L
#define FREQ_SCALE 1136635L

/*   */

#define IF1_INVERSE	0	// true: the lo LO2 in above IF1 (true, if 45.5 MHz)

#define LO2_PLL_N	25		/* for 80 MHz LO2 */

#define PHASE_RESOLUTION 32	/*  FTW  DDS */


/* Board hardware configuration */
#define PLL1_TYPE PLL_TYPE_ADF4001
#define PLL2_TYPE PLL_TYPE_ADF4001
//#define DDS1_TYPE DDS_TYPE_AD9834
#define DDS1_TYPE DDS_TYPE_AD9852
//#define DDS1_TYPE DDS_TYPE_AD9951
//#define DDS2_TYPE DDS_TYPE_AD9852
//#define DDS2_TYPE DDS_TYPE_AD9951
#define DDS2_TYPE DDS_TYPE_AD9834

#define AMP1_TYPE AMP_TYPE_AD8320
#define AMP2_TYPE AMP_TYPE_AD8320
#define AMP3_TYPE AMP_TYPE_AD8320

#define LO3_POWER 0 //2
#define TUNE_BOTTOM 100000		/*    */
#define TUNE_TOP 54000000		/*    */


#define LO2FREQ (REFERENCE_FREQ / LO2_PLL_R * LO2_PLL_N)	/*    */



#endif // Model 80455

#if MODEL_64455

#define IF3_MODEL IF3_TYPE_455
#define LO1MODE_HYBRID	1
// model 

#define SYNTH_R1 21	/*   DDS -     PLL */
#define SYNTH_FREQMIN	64555000L		/*     */
#define SYNTH_CFCENTER	10700000L	/*      DDS */

#define FREQ_DENOM 1000000L
#define FREQ_SCALE 1178340L

/*   */

#define IF1_INVERSE	0	// true: the lo LO2 in above IF1 (true, if 45.5 MHz)


#if 0
/* ,   ,     */
#define PHASE_RESOLUTION 32	/*  FTW  DDS */

/* Board hardware configuration */
#define DDS1_TYPE DDS_TYPE_AD9852
#define DDS2_TYPE DDS_TYPE_AD9834
#define PLL1_TYPE PLL_TYPE_ADF4001
#define PLL2_TYPE PLL_TYPE_ADF4001


#define REFERENCE_FREQ	12800000L
#define LO2_PLL_R	4		/* For 3.2 MHz phase detector freq */
#define IMU 4
#define LO2_PLL_R_CALC	(IMU*LO2_PLL_R)		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */
#define DDS_CLOCK_MULT (IMU)
#define SYNTH_DDSOSC	(IMU*REFERENCE_FREQ)	  /*     DDS */
#define	DDSAD9951CLKGT250	0		/* set to 1 if dds clock greater then 250 MHz */
#define LO2_PLL_N	20		/* for 64 MHz LO2 */
#define LO3_POWER 2		/*  AD9834     12.8  */

#elif 0
/* ,    DDS -  AD9834,     64  (   2 -  DDS) */

#define PHASE_RESOLUTION 28	/*  FTW  DDS */

/* Board hardware configuration */
#define DDS1_TYPE DDS_TYPE_AD9834
#define DDS2_TYPE DDS_TYPE_AD9834
#define PLL1_TYPE PLL_TYPE_ADF4001
//#define PLL2_TYPE PLL_TYPE_ADF4001


#define REFERENCE_FREQ	32000000L
#define LO2_PLL_R	10		/* For 3.2 MHz phase detector freq */
#define IMU 1
#define LO2_PLL_R_CALC	(IMU*LO2_PLL_R)		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */
#define DDS_CLOCK_MULT (IMU)
#define SYNTH_DDSOSC	(IMU*REFERENCE_FREQ)	  /*     DDS */
#define	DDSAD9951CLKGT250	0		/* set to 1 if dds clock greater then 250 MHz */
#define LO2_PLL_N	20		/* for 64 MHz LO2 */
#define LO3_POWER 0 //2

#elif 1
/*   ""  -  AD9951 */
/* Board hardware configuration */
#define PHASE_RESOLUTION 32	/*  FTW  DDS */
#define DDS1_TYPE DDS_TYPE_AD9951
#define DDS2_TYPE DDS_TYPE_AD9951

//#define DDS1_TYPE DDS_TYPE_AD9852
//#define DDS2_TYPE DDS_TYPE_AD9834
#define PLL1_TYPE PLL_TYPE_ADF4001
#define PLL2_TYPE PLL_TYPE_ADF4001


#define AMP1_TYPE AMP_TYPE_AD8320
#define AMP2_TYPE AMP_TYPE_AD8320
#define AMP3_TYPE AMP_TYPE_AD8320


#define REFERENCE_FREQ	12800000L
#define LO2_PLL_R	4		/* For 3.2 MHz phase detector freq */
#define IMU 4
#define LO2_PLL_R_CALC	(IMU*LO2_PLL_R)		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */
#define DDS_CLOCK_MULT (IMU)
#define SYNTH_DDSOSC	(IMU*REFERENCE_FREQ)	  /*     DDS */
#define	DDSAD9951CLKGT250	0		/* set to 1 if dds clock greater then 250 MHz */
#define LO2_PLL_N	20		/* for 64 MHz LO2 */
#define LO3_POWER 0 //2

#endif

#define TUNE_BOTTOM 100000		/*    */
#define TUNE_TOP 60000000		/*    */


#define LO2FREQ (REFERENCE_FREQ / LO2_PLL_R * LO2_PLL_N)



#endif // Model 64455


#if MODEL_65_185

#define LO1MODE_HYBRID	1
// model MODEL_65_185

#define PHASE_RESOLUTION 32	/*  FTW  DDS */
#define SYNTH_R1 17					/*   DDS -     PLL */
#define SYNTH_FREQMIN	65000000	/*     */
#define SYNTH_DDSOSC	50000000	/*     DDS */
#define SYNTH_CFCENTER	10700000	/*      DDS */

#define FREQ_DENOM 1000000L
#define FREQ_SCALE 1298867L


/*   */


/* Board hardware configuration */
#define PLL1_TYPE PLL_TYPE_LMX2306 //PLL_TYPE_ADF4001
//#define PLL2_TYPE PLL_TYPE_LMX2306 //PLL_TYPE_ADF4001
#define DDS1_TYPE DDS_TYPE_AD9852
//#define DDS1_TYPE DDS_TYPE_AD9951
// #define DDS2_TYPE DDS_TYPE_AD9852
//#define DDS2_TYPE DDS_TYPE_AD9951
#define AMP1_TYPE AMP_TYPE_AD8320
//#define AMP2_TYPE AMP_TYPE_AD8320
//#define AMP3_TYPE AMP_TYPE_AD8320

#define LO2_PLL_R	128		/* For 0.1 MHz phase detector freq */

#define DDS_CLOCK_MULT 1
#define LO2_PLL_R_CALC	455		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */


#endif // Model 45

#if MODEL_UPS9951
#define LO1MODE_DIRECT	1
// model direct

#define PHASE_RESOLUTION 32	/*  FTW  DDS */
#define SYNTH_R1 17					/*   DDS -     PLL */
#define SYNTH_FREQMIN	65000000	/*     */
#define SYNTH_DDSOSC	288000000	/*     DDS */
#define SYNTH_CFCENTER	10700000	/*      DDS */

#define FREQ_DENOM 1000000L
#define FREQ_SCALE 1298867L


/*   */


/* Board hardware configuration */
//#define PLL1_TYPE PLL_TYPE_LMX2306 //PLL_TYPE_ADF4001
//#define PLL2_TYPE PLL_TYPE_LMX2306 //PLL_TYPE_ADF4001
//#define DDS1_TYPE DDS_TYPE_AD9852
#define DDS1_TYPE DDS_TYPE_AD9951
// #define DDS2_TYPE DDS_TYPE_AD9852
//#define DDS2_TYPE DDS_TYPE_AD9951
#define AMP1_TYPE AMP_TYPE_AD8320
//#define AMP2_TYPE AMP_TYPE_AD8320
//#define AMP3_TYPE AMP_TYPE_AD8320


#define LO2_PLL_N	128		/* For 0.1 MHz phase detector freq */
#define LO2_PLL_R	128		/* For 0.1 MHz phase detector freq */

#define DDS_CLOCK_MULT 20
#define LO2_PLL_R_CALC	455		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */

#endif // model direct

#if MODEL_35

#define LO1MODE_HYBRID	1
#define IF3_MODEL IF3_TYPE_215

#define REFERENCE_FREQ	12800000L
#define PHASE_RESOLUTION 32	/*  FTW  DDS */

/* Board hardware configuration */
#define PLL1_TYPE PLL_TYPE_ADF4001
#define PLL2_TYPE PLL_TYPE_ADF4001

#define DDS1_TYPE DDS_TYPE_AD9951
#define DDS2_TYPE DDS_TYPE_AD9951
#define AMP1_TYPE AMP_TYPE_AD8320
#define AMP2_TYPE AMP_TYPE_AD8320
#define AMP3_TYPE AMP_TYPE_AD8320

/*
	KATRAN model definitions
*/

#define IF1_INVERSE	1	// true: the lo LO2 in above IF1 (true, if 45.5 MHz)

// for programming PLL2

#if 0

#define LO2_PLL_R	128		/* For 0.1 MHz phase detector freq */
#define IMU 1
#define LO2_PLL_R_CALC	(IMU*LO2_PLL_R)		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */
#define DDS_CLOCK_MULT (IMU)
#define SYNTH_DDSOSC	(IMU*REFERENCE_FREQ)	  /*     DDS */
#define	DDSAD9951CLKGT250	0		/* set to 1 if dds clock greater then 250 MHz */

#elif 1

#define LO2_PLL_R	128		/* For 0.1 MHz phase detector freq */
#define IMU 4
#define LO2_PLL_R_CALC	(IMU*LO2_PLL_R)		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */
#define DDS_CLOCK_MULT (IMU)
#define SYNTH_DDSOSC	(IMU*REFERENCE_FREQ)	  /*     DDS */
#define	DDSAD9951CLKGT250	0		/* set to 1 if dds clock greater then 250 MHz */

#define BFOFREQ 215000



#endif

#define SYNTH_FREQMIN	35785000	/*     */

#define FREQ_DENOM 1000000
#define FREQ_SCALE 1168812

#define LO2_PLL_N	350		/* for 35.0 MHz LO2 */
#define SYNTH_R1	31	/* divider afrer DSS1 unit */
#define SYNTH_CFCENTER	10700000	/*      DDS */
#define LO2FREQ (REFERENCE_FREQ / LO2_PLL_R * LO2_PLL_N)

static const char fq3_USB [32] = "213150";	//"500000";	// edge of filter
static const char fq3_LSB [32] = "216850";	//"496300";	// edge of filter
static const char fq3_CW  [32] = "215000";	//"498150";	// center of filter
static const char asclowfreq [32] = 	"35785000";	/* Lowest frequency of 1-st LO */
static const char asctopfreq [32] = 	"66785000";	/* Lowest frequency of 1-st LO */

#define LO3_POWER 0 //2
#define TUNE_BOTTOM 1000000
#define TUNE_TOP 32000000


#endif

#if MODEL_70
#define LO1MODE_HYBRID	1
#define IF3_MODEL IF3_TYPE_500
// 

#define REFERENCE_FREQ	12800000L
#define LO2_PLL_R	128		/* For 0.1 MHz phase detector freq */
#define IMU 1
#define LO2_PLL_R_CALC	(IMU*LO2_PLL_R)		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */
#define DDS_CLOCK_MULT (IMU)
#define SYNTH_DDSOSC	(IMU*REFERENCE_FREQ)	  /*     DDS */
#define	DDSAD9951CLKGT250	0		/* set to 1 if dds clock greater then 250 MHz */


#define SYNTH_R1 15					/*   DDS -     PLL */
#define SYNTH_FREQMIN	70100000L	/*     */
#define SYNTH_CFCENTER	10700000L	/*      DDS */

#define FREQ_DENOM 1000000
#define FREQ_SCALE 1153257


/*   */

#define IF1_INVERSE	0	// true: the lo LO2 in above IF1 (true, if 45.5 MHz)

#define LO2_PLL_N	695/* for 45.5 MHz LO2 */


#define PHASE_RESOLUTION 28	/*  FTW  DDS */
//#define PHASE_RESOLUTION 32	/*  FTW  DDS */


/* Board hardware configuration */
#define PLL1_TYPE PLL_TYPE_ADF4001
#define PLL2_TYPE PLL_TYPE_ADF4001
#define DDS1_TYPE DDS_TYPE_AD9852
#define DDS2_TYPE DDS_TYPE_AD9834 


#define LO3_POWER 0 //2
#define TUNE_BOTTOM 100000
#define TUNE_TOP 54000000


#define LO2FREQ (REFERENCE_FREQ / LO2_PLL_R * LO2_PLL_N)


#endif // Model 70
#if MODEL_8P8
#define LO1DIVIDEVCO	1		/*     */
#define LO1MODE_DIRECT	1
// 
#if ! defined(BOARD_TYPE_UPSC9951)
#error Please, define board type BOARD_TYPE_UPSC9951
#endif
#define REFERENCE_FREQ	100000000L
#define LO2_PLL_R	1000		/* For 0.1 MHz phase detector freq */
#define IMU 1
#define LO2_PLL_R_CALC	(IMU*LO2_PLL_R)		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */
#define DDS_CLOCK_MULT (IMU)
#define SYNTH_DDSOSC	(IMU*REFERENCE_FREQ)	  /*     DDS */
#define	DDSAD9951CLKGT250	0		/* set to 1 if dds clock greater then 250 MHz */


#define SYNTH_R1 1					/*   DDS -     PLL */
#define SYNTH_FREQMIN	50000000UL	/*     */
#define SYNTH_CFCENTER	10700000L	/*      DDS */

#define FREQ_DENOM 1000000
#define FREQ_SCALE 1153257


/*   */

#define IF1_INVERSE	0	// true: the lo LO2 in above IF1 (true, if 45.5 MHz)

#define LO2_PLL_N	0	/* for 45.5 MHz LO2 */


//#define PHASE_RESOLUTION 28	/*  FTW  DDS */
#define PHASE_RESOLUTION 32	/*  FTW  DDS */


/* Board hardware configuration */
//#define PLL1_TYPE PLL_TYPE_ADF4001
//#define PLL2_TYPE PLL_TYPE_ADF4001
#define DDS1_TYPE DDS_TYPE_AD9951
#define DDS2_TYPE DDS_TYPE_AD9951
#define AMP1_TYPE AMP_TYPE_AD8320
#define AMP3_TYPE AMP_TYPE_AD8320


#define LO3_POWER 0 //2
#define TUNE_BOTTOM 100000
#define TUNE_TOP 54000000


#define LO2FREQ 0


#endif // MODEL_8P8

#ifdef MODEL_4Z5KY
#define LO1MODE_DIRECT	1
// 
#define REFERENCE_FREQ	50000000L
#define LO2_PLL_R	1000		/* For 0.1 MHz phase detector freq */
#define IMU 8
#define LO2_PLL_R_CALC	(IMU*LO2_PLL_R)		/* result of divide DDS Fclk to PLL2 compare freq (0.1 MHz) */
#define DDS_CLOCK_MULT (IMU)
#define SYNTH_DDSOSC	(IMU*REFERENCE_FREQ)	  /*     DDS */
#define	DDSAD9951CLKGT250	1		/* set to 1 if dds clock greater then 250 MHz */


#define SYNTH_R1 1					/*   DDS -     PLL */
#define SYNTH_FREQMIN	70100000L	/*     */
#define SYNTH_CFCENTER	10700000L	/*      DDS */

#define FREQ_DENOM 1000000
#define FREQ_SCALE 1153257


/*   */

#define IF1_INVERSE	0	// true: the lo LO2 in above IF1 (true, if 45.5 MHz)

#define LO2_PLL_N	0	/* for 45.5 MHz LO2 */


//#define PHASE_RESOLUTION 28	/*  FTW  DDS */
#define PHASE_RESOLUTION 32	/*  FTW  DDS */


/* Board hardware configuration */
//#define PLL1_TYPE PLL_TYPE_ADF4001
//#define PLL2_TYPE PLL_TYPE_ADF4001
#define DDS1_TYPE DDS_TYPE_AD9951
//#define DDS2_TYPE DDS_TYPE_AD9951
//#define AMP1_TYPE AMP_TYPE_AD8320
//#define AMP3_TYPE AMP_TYPE_AD8320


#define LO3_POWER 0 //2
#define TUNE_BOTTOM 100000
#define TUNE_TOP 30000000


#define LO2FREQ (61925000-455000)

#endif // MODEL_4Z5KY

#if MODEL_RD3AY

#ifndef BOARD_SUPPORT_RD3AY
#error BOARD_SUPPORT_RD3AY should be defined for model RD3AY
#endif

#define LO1DIVIDEVCO	1		/*     */
#define LO1MODE_FIXSCALE	1	
#define IF3_MODEL IF3_TYPE_8868
#define IF1_INVERSE	0	// true: the lo LO2 in above IF1 (true, if 45.5 MHz)

#define SYNTH_R1 256


#define DDS1_TYPE DDS_TYPE_AD9832
#define PHASE_RESOLUTION 32	/*  FTW  DDS */

#define TUNE_BOTTOM 100000
#define TUNE_TOP 30000000

#define DDS_CLOCK_MULT 1
#define SYNTH_DDSOSC 16000000
#define LO3_POWER 0
#define LO2FREQ 0


#endif


#if MODEL_DCRX
#define LO1MODE_DIRECT	1
#define IF3_MODEL IF3_TYPE_DCRX

#ifndef BOARD_SUPPORT_DCRX
#error BOARD_SUPPORT_DCRX should be defined for model MODEL_DCRX
#endif

#define DDS1_TYPE DDS_TYPE_AD9951
#define	DDSAD9951CLKGT250	0		/* set to 1 if dds clock greater then 250 MHz */

#define IF1_INVERSE 0
#define TUNE_BOTTOM 100000
#define TUNE_TOP 30000000
#define DDS_CLOCK_MULT 1
#define SYNTH_DDSOSC 200000000

#define LO3_POWER 0
#define LO2FREQ 0

#define PHASE_RESOLUTION 32	/*  FTW  DDS */

#endif


#endif /* PRODUCT_H_INCLUDED */
