/* spifuncs.h */
void prog_bit(
	unsigned char target,	/* addressing to chip */
	uint8_t bitv	/* zero or non-zero values */
	);

void prog_select(
	unsigned char target,	/* addressing to chip */
	fastbool_t select	/* zero - done sending data, non-zero - start sending data */
	);
void prog_val(
	unsigned char target,	/* addressing to chip */
	vt_t value,
	fastcount_t n				/* number of bits to send */
	);
void prog_phbits(
	unsigned char target,	/* addressing to chip */
	const phase_t * val,
	fastcount_t i,				/* left of 1-st bit to set */
	fastcount_t n				/* number of bits to send */
	);

uint8_t phase_getbit(
	const phase_t * v,
	fastcount_t i		/* bit position, LSB = 0 */
	);

void 
prog_select_init(void);



void lpt_writeb(unsigned char c);
void lpt_and_writeb(unsigned char data, unsigned char mask);
void lpt_set_d0_0(void);
void lpt_set_d0_1(void);
void lpt_set_d1(uint8_t value);
void lpt_set_d2(uint8_t value);
void lpt_set_d3(uint8_t value);
void lpt_set_d4(uint8_t value);
void lpt_set_d5(uint8_t value);
void lpt_set_d6(uint8_t value);
void lpt_set_d7(uint8_t value);

// active high
#define fclk_off() lpt_set_d5(0)	// chip select inactive
#define fclk_on() lpt_set_d5(1)	// chip select active

#define SCLK_SET() lpt_set_d0_1(); //lpt_set_d0(1);
#define SCLK_CLR() lpt_set_d0_0(); //lpt_set_d0(0);
#define SDO_SET(val) lpt_set_d1((val));

