/*
	synthcalcs.h
*/
#ifndef SYNTHCACS_H_INCLUDED
#define SYNTHCACS_H_INCLUDED

#include <stdbool.h>
#include <stdint.h>

typedef unsigned long long ftw_t;	/* ,         */
typedef unsigned char fastcount_t;
typedef bool fastbool_t;	// GCC AVR type
typedef unsigned char vt_t;
typedef ftw_t phase_t;

extern phase_t r1_ph; // = SYNTH_R1;
extern const phase_t phase_0;
void synth_init(
	unsigned long ddsclock, 	/*       */
	unsigned char ddsmult);

void phase_fromulong(
	phase_t * o,
	unsigned long arg
	);
void phase_fromuint(
	phase_t * o,
	unsigned arg
	);

void synth_lo3_setfreq(
	uint32_t fq1,	/* ,      DDS */
	unsigned char freqpow
	);
void synth_lo1_setfreq(
	uint32_t freq	/*      */
	);

#endif /* SYNTHCACS_H_INCLUDED */
